# Class RgbPaperType3D.RgbPaper3D

java.lang.Object
uk.ac.starlink.ttools.plot2.paper.RgbPaperType.RgbPaper
uk.ac.starlink.ttools.plot2.paper.RgbPaperType3D.RgbPaper3D

All Implemented Interfaces:
  `Paper`

Enclosing class:
  `RgbPaperType3D`

protected abstract static class RgbPaperType3D.RgbPaper3D extends RgbPaperType.RgbPaper
Paper for use by this type.

Since:
  14 Feb 2013
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`RgbPaper3D(PaperType paperType, Rectangle bounds)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`protected abstract void`
`placePixels(int xoff, int yoff, double dz, Pixer pixer, Color color)`
Paints the pixels of a pixel iterator in a given colour at a given 3d position.

### Methods inherited from class RgbPaperType.RgbPaper

`flush, getBounds, getPaperType, getPixelIndex, getRgbImage, placeDecal`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface Paper

`canMerge, createSheet, mergeSheet`

## Constructor Details

### RgbPaper3D

public RgbPaper3D(PaperType paperType, Rectangle bounds)
Constructor.

Parameters:
  `paperType` - paper type instance creating this paper
  `bounds` - plot bounds

## Method Details

### placePixels

protected abstract void placePixels(int xoff, int yoff, double dz, Pixer pixer, Color color)
Paints the pixels of a pixel iterator in a given colour at a given 3d position. Subclasses implement this method to perform the actual pixel compositing. The supplied pixer will already have been clipped, so implementations don't need to worry about checking the positions are within the bounds of this paper. Implementations can (and usually should) use the `RgbPaperType.RgbPaper.getPixelIndex(int, int, Pixer)` method to address pixels of the RgbImage buffer.

Parameters:
  `xoff` - X graphics offset
  `yoff` - Y graphics offset
  `dz` - depth coordinate, lower value means closer to viewer
  `pixer` - clipped pixel iterator, not null
  `color` - painting colour